## emoslib 4.5.5

=== debian/changelog ===
emoslib (2:4.5.5-2) unstable; urgency=medium

  * Standards-Version: 4.1.5
  * Update URLs in d/watch

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Jul 2018 23:16:10 +0100

emoslib (2:4.5.5-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.4

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Apr 2018 09:33:42 +0100

emoslib (2:4.5.4-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.3
  * Set VCS to point to salsa.debian.org
  * Now installs in /usr directory; change install scripts, rules as needed
  * Delete broken symlinks in libemos-data. Closes: #867275
  * lintian-overrides to ignore in correct warnings 
  * Remove obsolete patches:
    - config.patch
    - wvqlid2.patch
    - huge.patch
    - links-fix.patch
  * Set GRIB_SAMPLES_PATH=/usr/share/eccodes/samples for tests
    
 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 03 Mar 2018 11:06:06 +0000

=== debian/control ===
Source: emoslib
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>=10), 
 gfortran, 
 cmake (>= 2.8.11), 
 libboost-dev (>= 1.47.0), 
 libboost-test-dev, 
 chrpath,
 libeccodes-dev (>= 2.4.1),
 libeccodes-tools | libgrib-api-tools,
 libopenjp2-7-dev,
 zlib1g-dev,
 libfftw3-dev,
 libpython2.7-dev, 
 libnetcdf-dev
Standards-Version: 4.1.5
Homepage: https://software.ecmwf.int/wiki/display/EMOS/Emoslib
Vcs-Browser: https://salsa.debian.org:/science-team/emos
Vcs-Git: https://salsa.debian.org:/science-team/emos.git

Package: libemos0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data
Pre-Depends: ${misc:Pre-Depends}
Description: ECMWF Interpolation Library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.

Package: libemos-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libemos0d ( = ${binary:Version}), ${misc:Depends}, libeccodes-tools | libemos-bin:any 
Recommends: pkg-config
Description: ECMWF Interpolation Library - development
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the static libraries and headers needed to build 
 applications against libemos.

Package: libemos-bin
Section: libs
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data, libeccodes-tools
Description: ECMWF Interpolation Library - binaries
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB,
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological
 archival and retrieval system (MARS) and also by the ECMWF graphics
 package MetView.
 .
 This package provide bufr-* and other tools

Package: libemos-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files for the ECMWF Interpolation library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the data files needed by EMOSLIB.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

export DEB_LDFLAGS_MAINT_PREPEND := -Wl,-z,defs -Wl,--as-needed

export ECCODES_DEFINITION_PATH=/usr/share/eccodes/definitions/
export GRIB_DEFINITION_PATH=/usr/share/eccodes/definitions/
export ECCODESX_SAMPLES_PATH=/usr/share/eccodes/samples
export GRIB_SAMPLES_PATH=/usr/share/eccodes/samples

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH:=$(shell dpkg --print-architecture)
AUTOGENERATED:= libemos-dev.install libemos-dev.links libemos0d.install
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
CMAKE_DIR:=debian/tmp/share/libemos/cmake
DO_TEST:=true


# Do tests on little-endian only for the moment;
ENDIAN:=$(shell dpkg-architecture -qDEB_BUILD_ARCH_ENDIAN)

FPIC_LIST:= "s390x amd64 ppc64el m68k sparc64"
ifneq (,$(findstring $(ARCH),$(FPIC_LIST)))
  FPIC:= -fPIC
else
  FPIC:= -fpic
endif

MCMODEL_FLAGS:=''
BUILD_FLAGS:=''

ifeq ($(ARCH), amd64)
  MCMODEL_FLAGS:= -mcmodel=medium
endif
ifeq ($(ARCH), sparc64)
  MCMODEL_FLAGS:= -mcmodel=medany
endif
ifeq ($(ARCH), ppc64el)
  MCMODEL_FLAGS:= -mcmodel=large
endif
ifeq ($(ARCH), hurd-i386)
  BUILD_FLAGS:= ' -D__GNU__'
endif

override_dh_auto_test:
	# Need to be installed into debian/tmp before tests
	cd obj-* && $(MAKE) install
	# Need links for tests.
	(cd bufrtables && sh ./links.sh)
	 $(ENDIAN)==little && dh_auto_test || echo "Tests disabled on bigendian systems for the moment"

override_dh_auto_clean:
	find bufrtables -type l -delete
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dgrib_api_BASE_DIR=/usr \
		-DECBUILD_LOG_LEVEL=DEBUG \
		-DENABLE_FFTW=ON \
		-DENABLE_LITTLE_ENDIAN=$(LITTLE) \
		-DCMAKE_INSTALL_PREFIX=$(DESTDIR) \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_SHARED_LIBS=ON \
		-DDISABLE_OS_CHECK=ON \
		-DMCMODEL_FLAGS=${MCMODEL_FLAGS} \
		-DBUILD_FLAGS=${BUILD_FLAGS} \
		-DFPIC=${FPIC} \
		-DINSTALL_LIBDIR=${LIBDIR} \
		-DINTERPOL_TABLES_PATH=/usr/share/emos \
		-DBUFR_TABLES_PATH=/usr/share/emos/bufrtables \
		-DTEST_BUFR_TABLES_PATH=${CURDIR}/bufrtables
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
		done

override_dh_auto_build:
	dh_auto_build

override_dh_auto_install:
	cd obj-* && $(MAKE) install
	for d in debian/tmp/bin/* ; do \
		( chrpath -d $$d || echo "Ignoring non-ELF file errors") ; done
	chrpath -d debian/tmp/lib/*.0d
	(cd $(DESTDIR)/share/libemos/tables/bufrtables && sh ./links.sh)
	# delete broken symlinks
	( cd $(DESTDIR)/share/libemos/tables/bufrtables/ && file * | grep broken | cut -f1 -d: | xargs rm )
	# Now in libeccodes
	rm -f debian/tmp/bin/bufr_filter
	# Fix broken paths 
	cat ${CMAKE_DIR}/libemos-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR}/tmp
	mv ${CMAKE_DIR}/tmp ${CMAKE_DIR}/libemos-targets-release.cmake
	# Change default from emos to emos_shared to link against shared libs in metview, etc.
	grep -v LIBEMOS_SELF_LIBRARIES ${CMAKE_DIR}/libemos-config.cmake | \
		sed -e 's%.*set( libemos_BASE_DIR.*%set( libemos_BASE_DIR /usr )%' > ${CMAKE_DIR}/tmp
	mv ${CMAKE_DIR}/tmp ${CMAKE_DIR}/libemos-config.cmake  
	echo >> ${CMAKE_DIR}/libemos-config.cmake 
	echo "set( LIBEMOS_SELF_LIBRARIES    "emos_shared" )" >> ${CMAKE_DIR}/libemos-config.cmake

## emoslib 4.5.9

=== CMakeLists.txt ===
################################################################################
# cmake options:
#   -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#   -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#   -DCMAKE_C_COMPILER=gcc
#   -CMAKE_Fortran_COMPILER=gfortran
#
#   -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#   -DBUILD_SHARED_LIBS=OFF

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( libemos )

enable_language( Fortran )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.6 )

ecbuild_add_option( FEATURE INSTALL_TABLES   DESCRIPTION "install BUFR/GRIBex/LSM tables"                                               DEFAULT ON )
ecbuild_add_option( FEATURE INSTALL_TOOLS    DESCRIPTION "install BUFR/GRIBex tools"                                                    DEFAULT ON )
ecbuild_add_option( FEATURE FORTRAN90        DESCRIPTION "enable tools which need Fortran 90 (only required for FC=pgf77)"              DEFAULT ON )
ecbuild_add_option( FEATURE SINGLE_PRECISION DESCRIPTION "enable single precision version of library (in addition to double precision)" DEFAULT ON )
ecbuild_add_option( FEATURE GRIBEX_ABORT     DESCRIPTION "abort execution on GRIBex calls"                                              DEFAULT ON )

ecbuild_add_option( FEATURE REQUIRE_FFTW     DESCRIPTION "require package: Fastest Fourier Transform in the West" DEFAULT ON )
ecbuild_add_option( FEATURE FFTW             DESCRIPTION "Fastest Fourier Transform in the West"                  DEFAULT ON REQUIRED_PACKAGES FFTW )
set_package_properties( FFTW PROPERTIES TYPE RECOMMENDED PURPOSE "allows interpolation of spectral to octahedral reduced Gaussian grid" )

ecbuild_add_option( FEATURE LIBEMOS_BUFRDC        DESCRIPTION "enable BUFR decoding functionality" DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_INTERPOLATION DESCRIPTION "enable interpolation functionality" DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_GRIBEX        DESCRIPTION "enable GRIBex functionality"        DEFAULT ON )
ecbuild_add_option( FEATURE LIBEMOS_TESTS_REGRESS DESCRIPTION "additional tests: regression"       DEFAULT OFF )

ecbuild_add_option( FEATURE LIBEMOS_BUILD_SHARED_LIBS DESCRIPTION "build shared libraries (unsupported)"   DEFAULT OFF )

################################################################################
# compiler/linker flags

if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
  set( emos_special_system_def linux FOPEN64 )
elseif( ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" )
  set( emos_special_system_def darwin )
endif()

get_filename_component(Fortran_COMPILER_NAME ${CMAKE_Fortran_COMPILER} NAME)

# double precision flags: only for d.p. Fortran-based targets (compiling & linking)
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  set(emos_double_precision_flags "-fdefault-real-8 -fdefault-double-8")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  set(emos_double_precision_flags "-r8 -i4")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  set(emos_double_precision_flags "-r8 -i4")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  set(emos_double_precision_flags "-s integer32 -s real64")
else()
  set(emos_double_precision_flags "")
endif()

# build type flags
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  ecbuild_add_fortran_flags("-ffixed-line-length-none -fcray-pointer -fno-second-underscore -Wuninitialized -Wunused-variable -DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-O2 -mtune=native" BUILD RELEASE)
  ecbuild_add_fortran_flags("-O2 -mtune=native" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"                BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"                BUILD DEBUG)
  if(ECBUILD_MACRO_VERSION VERSION_GREATER 1.9)
    ecbuild_remove_fortran_flags("-fcheck=bounds" BUILD DEBUG)
  endif()
  include_directories(${CMAKE_Fortran_MODULE_DIRECTORY})  # EMOS-243: support for older gfortran 4.1 compiler
  set(emos_special_compiler_def "gfortran")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  ecbuild_add_fortran_flags("-DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-f77rtl"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-f77rtl -g" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-f77rtl -g" BUILD DEBUG)
  if(ECBUILD_MACRO_VERSION VERSION_GREATER 1.9)
    ecbuild_remove_fortran_flags("-check bounds" BUILD DEBUG)
  endif()
  if(HAVE_LIBEMOS_GRIBEX)
    ecbuild_add_fortran_flags("-O1" BUILD RELEASE)         # otherwise breaks GRIBex second-order packing
    ecbuild_add_fortran_flags("-O1" BUILD RELWITHDEBINFO)  # otherwise breaks GRIBex second-order packing
    ecbuild_add_fortran_flags("-O0" BUILD DEBUG)
  else()
    ecbuild_add_fortran_flags("-O3" BUILD RELEASE)
    ecbuild_add_fortran_flags("-O2" BUILD RELWITHDEBINFO)
    ecbuild_add_fortran_flags("-O0" BUILD DEBUG)
  endif()
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  ecbuild_add_fortran_flags("-fast -Kieee -Mvect=prefetch -noswitcherror -Mextend")
  ecbuild_add_fortran_flags("-O2"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-g -O2" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-g"     BUILD DEBUG)
  include_directories(${CMAKE_Fortran_MODULE_DIRECTORY})  # EMOS-314: support for pgi 16.4
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  ecbuild_add_fortran_flags("-ev -Wl,--as-needed -h PIC -emf -hflex_mp=conservative -hfp1 -hadd_paren -DSHAREDMEMORY")
  ecbuild_add_fortran_flags("-G2"       BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-G0 -hfp0" BUILD DEBUG)
  ecbuild_add_c_flags("-Wl,--as-needed -h PIC -DSHAREDMEMORY")
else()
  ecbuild_warn("No optimized Fortran compiler flags are known, we just try -O2...")
  ecbuild_add_fortran_flags("-O2"    BUILD RELEASE)
  ecbuild_add_fortran_flags("-O2 -g" BUILD RELWITHDEBINFO)
  ecbuild_add_fortran_flags("-O0 -g" BUILD DEBUG)
endif()


if(LIBEMOS_BUILD_SHARED_LIBS)
  ecbuild_warn("Building libemos as shared library is unsupported and at own risk")
  set( LIB_TYPE SHARED )
else()
  set( LIB_TYPE STATIC )
endif()


################################################################################
# extra packages and projects

ecbuild_debug_var(CMAKE_PREFIX_PATH)
set( ECCODES_FAIL_MSG
    "Note: grib_api can be used instead (select with -DENABLE_ECCODES=OFF), "
    "but we strongly advise you to upgrade to ecCodes. "
    "See https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home\n" )
ecbuild_add_option( FEATURE ECCODES DESCRIPTION "Use eccodes instead of grib_api"
                    REQUIRED_PACKAGES "PROJECT eccodes VERSION 2.4.1 REQUIRED FAILURE_MSG ECCODES_FAIL_MSG"
                    DEFAULT ON )

if( HAVE_ECCODES)
  set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
  set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
  set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
  set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
  set( grib_handling_pkg eccodes )
else()
  ecbuild_use_package( PROJECT grib_api VERSION 1.23.1 REQUIRED
      FAILURE_MSG "We strongly advise to use ecCodes (enable with -DENABLE_ECCODES=ON)" )
  set( grib_handling_pkg grib_api )
endif()

################################################################################
# contents

ecbuild_declare_project()

# project export variables
set( LIBEMOS_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
set( LIBEMOS_LIBRARIES    emos ${GRIB_API_LIBRARIES} )

set_directory_properties(PROPERTIES COMPILE_DEFINITIONS "${GRIB_API_DEFINITIONS}" )

include_directories( ${LIBEMOS_INCLUDE_DIRS}  )
include_directories( ${GRIB_API_INCLUDE_DIRS} )
if( HAVE_FFTW )
  include_directories( ${FFTW_INCLUDES} )
elseif( HAVE_REQUIRE_FFTW )
  ecbuild_critical("\nCannot build without FFTW support (support is required)!")
endif()

if( BUFR_TABLES_PATH )
  if( NOT IS_ABSOLUTE "${BUFR_TABLES_PATH}" )
    set( BUFR_TABLES_PATH "${CMAKE_INSTALL_PREFIX}/${BUFR_TABLES_PATH}" )
  endif()
else()
  set( BUFR_TABLES_PATH "${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/../bufrdc_tables/" )
endif()
add_definitions( -DBUFR_TABLES_PATH="${BUFR_TABLES_PATH}" )
message( STATUS "BUFR_TABLES_PATH: ${BUFR_TABLES_PATH}" )

# get_directory_property( LIBEMOS_DEFINITIONS COMPILE_DEFINITIONS ) # don't export libemos definitions

# config header
ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/libemos )

configure_file( libemos_config.h.in  libemos_config.h  @ONLY )
configure_file( libemos_version.h.in libemos_version.h @ONLY )
configure_file( libemos_version.c.in libemos_version.c @ONLY )

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_config.h
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_version.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/libemos )


################################################################################
# sources

if( HAVE_LIBEMOS_INTERPOLATION AND NOT HAVE_LIBEMOS_GRIBEX )
  message( FATAL_ERROR "\nCannot build libemos interpolation without GRIBex support!\nPlease pass option to cmake -DENABLE_LIBEMOS_GRIBEX=ON")
endif()

add_subdirectory( common )
add_subdirectory( pbio )

if( HAVE_LIBEMOS_GRIBEX )
  add_subdirectory( gribex )
endif()

if( HAVE_LIBEMOS_INTERPOLATION )
  add_subdirectory( interpolation )
  add_subdirectory( sandbox )
endif()

if( HAVE_LIBEMOS_BUFRDC )
  add_subdirectory( bufrdc_wmo )
endif()

if( ENABLE_INSTALL_TOOLS )
  add_subdirectory( tools )
endif()

if( HAVE_TESTS )
  add_subdirectory( tests )
endif()

#DEFINITIONS  FORTRAN_NO_UNDERSCORE

if( HAVE_LIBEMOS_GRIBEX )
  if( ${Fortran_COMPILER_NAME} MATCHES "ifort" OR CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
    set_source_files_properties( ${gribex_srcs} PROPERTIES COMPILE_FLAGS "-O0" )
  endif()
endif( HAVE_LIBEMOS_GRIBEX )


list( APPEND libemos_srcs
  ${emos_common_src_files}
  ${interpolation_srcs}
  ${gribex_srcs}
  ${bufrdc_wmo_srcs}
  ${pbio_srcs} )


################################################################################
# tables: BUFR and LSM interpolation

# should we install the old tables?
# probably only for new architectures
if( ENABLE_INSTALL_TABLES )
  install(
    DIRECTORY
      bufrtables
      gribtables
      gribtemplates
    DESTINATION ${INSTALL_DATA_DIR}/tables
    FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )
endif()

### interpolation tables are always installed
if( NOT INTERPOL_TABLES_PATH )
  set( INTERPOL_TABLES_PATH "${INSTALL_DATA_DIR}/tables" )
endif()

# tables path to passed as PATH into compilation -D must be absolute
if( IS_ABSOLUTE "${INTERPOL_TABLES_PATH}" )
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${INTERPOL_TABLES_PATH}" )
else()
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${CMAKE_INSTALL_PREFIX}/${INTERPOL_TABLES_PATH}" )
endif()
ecbuild_info( "INTERPOL_TABLES_PATH:   ${INTERPOL_TABLES_PATH}" )

# copy the tables/interpol to the build directory
file( COPY tables/interpol DESTINATION ${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/tables )

# always install tables/interpol
install( DIRECTORY tables/interpol DESTINATION "${INTERPOL_TABLES_PATH}" FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )
install( CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink interpol ${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/tables/land_sea_mask)" )


################################################################################
# final definitions

list( APPEND LIBEMOS_DEFINITIONS
  ${emos_special_compiler_def}
  ${emos_special_system_def}
  REAL_8
  REAL_BIGGER_THAN_INTEGER
  POINTER_64
  _LARGEFILE64_SOURCE
  _FILE_OFFSET_BITS=64
  LITTLE_ENDIAN
  INTEGER_IS_INT
  ${GRIB_API_DEFINITIONS} )

# FIXME: LITTLE_ENDIAN is not portable!
# (EMOS-172: remove this flag, only used in GRIBEX, temporarily enabled for now)


################################################################################
# targets: libraries (single & douple p.) and version-check executable

set( LIBEMOS_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR} )

if( HAVE_SINGLE_PRECISION )

=== bufrdc_wmo/CMakeLists.txt ===
#
#   Sources for bufrdc
#
list( APPEND bufrdc_wmo_src_files
   bbuprs0.F
   bbuprs1.F
   bbuprs2.F
   bbuprs3.F
   bbuprt.F
   bbuprtbox.F
   buaug.F
   bubox.F
   bucrkey.F
   bucrekey.F
   buedd.F
   buens0.F
   buens1.F
   buens2.F
   buens3.F
   buens4.F
   buens5.F
   buepmrk.F
   buepmrkc.F
   buepwt.F
   buepwtc.F
   buerr.F
   buetab.F
   buetd.F
   buetdr.F
   buevar.F
   buexs0.F
   buexs1.F
   buexs2.F
   buexs3.F
   buexs3p.F
   buexs4.F
   buexs5.F
   bufren.F
   bufrex.F
   bugbts.F
   bugetbm.F
   buivar.F
   bunexs.F
   bunpck.F
   bunpks.F
   buoctn.F
   buoper.F
   buoperc.F
   bupck.F
   bupkey.F
   bupks.F
   bupmrk.F
   buprco.F
   buprq.F
   buprs0.F
   buprs1.F
   buprs2.F
   buprs3.F
   buprt.F
   buprtbox.F
   burep.F
   burepc.F
   burqc.F
   burquc.F
   bustop.F
   bus012.F
   busel.F
   buset.F
   busrp.F
   busrq.F
   bustdr.F
   buuatb.F
   buukey.F
   buunp.F
   buunps.F
   buupwt.F
   buxdes.F
   bugtll.F
   buexs33.F
   busel2.F
   bus0123.F
   get_name_unit.F
   mbufr_mars_filter.F
   fmmh.F
   btable.F
   ctable.F
   dtable.F
   btable1.F
   ctable1.F
   dtable1.F
   big_endian.F
   swap_bytes4.F
   swap_bytes8.F
   get_tables.F
   get_tables1.F
   get_free_unit.F
   busbytesR8.F
   busbytesR4.F
   bugbytesR8.F
   bugbytesR4.F
   buget_opera_image.F
   getcode.F
   getflag.F
   bu_check_s4s.F
   setlalo.F
)

foreach( src ${bufrdc_wmo_src_files} )
  list( APPEND bufrdc_wmo_srcs bufrdc_wmo/${src} )
endforeach()

set( bufrdc_wmo_srcs ${bufrdc_wmo_srcs} PARENT_SCOPE )

=== bufrtables/CMakeLists.txt ===
############################################################
# CMake options:
#
#   -DCMAKE_INSTALL_PREFIX="/usr/local/apps/libemos/tables/bufr/text/XXXYYY"  (optional: default is /usr/local )

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( bufrdc_tables C )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

set( ENABLE_OS_TESTS OFF )
set( ENABLE_OS_FUNCTIONS_TEST OFF )

include( ecbuild_system )

ecbuild_requires_macro_version( 2.0 )

###############################################################################
# project

ecbuild_declare_project()

math( EXPR TABLES_VERSION "100*${BUFRDC_TABLES_MAJOR_VERSION} + 10*${BUFRDC_TABLES_MINOR_VERSION} + ${BUFRDC_TABLES_PATCH_VERSION}")
set( TABLES_VERSION "000${TABLES_VERSION}" )

file(GLOB links_txt RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.TXT )
file(GLOB distincts RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.distinct )

# debug (warning: lots of output!)
# ecbuild_debug_var( links_txt )
# ecbuild_debug_var( distincts )

install( FILES ${distincts} DESTINATION ${INSTALL_DATA_DIR} )
install( FILES ${links_txt} DESTINATION ${INSTALL_DATA_DIR} )

ecbuild_info( "${PROJECT_NAME} version: ${TABLES_VERSION}" )
ecbuild_debug( "${PROJECT_NAME} installing to: ${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}" )

if( NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
  set( TEST_BUFR_TABLES_PATH "${PROJECT_SOURCE_DIR}" PARENT_SCOPE )
endif()

################################################################################
# finalize

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== cmake/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

file( GLOB_RECURSE ecbuild_support_files  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*" )

ecbuild_add_resources(  TARGET ${PROJECT_NAME}_ecbuild_support_files
						SOURCES_PACK
							${ecbuild_support_files} )

=== common/CMakeLists.txt ===
list( APPEND common_src_files
  JPointer.h
  fortint.h
  fortreal.h
  grprs.h
)

foreach( src ${common_src_files} )
  list( APPEND emos_common_src_files common/${src} )
endforeach()

set( emos_common_src_files ${emos_common_src_files} PARENT_SCOPE )

=== gribex/CMakeLists.txt ===

list( APPEND gribex_src_files
  ECMWFdefinitions.c
  ECMWFdefinitions.h
  abortx.F
  bufrin.F
  c2bitw.F
  c2cwid.F
  c2dosd.F
  c2gene.F
  c2ordr.F
  c2pack.F
  c2pkvw.F
  c2rnge.F
  c2rows.F
  calcop.F
  cheknum.F
  chktab2.F
  cmpck.F
  codeps.F
  comars.h
  comcomm.h
  comgrb.h
  confp.F
  confp2.F
  confp3.F
  confpa.F
  csect4.F
  csgnbt.c
  d2ordr.F
  d2rosd.F
  decext.F
  decfp.F
  decfp2.F
  decogb.F
  decogc.F
  decogd.F
  decogr.F
  decops.F
  decops2.F
  dggsec2.F
  dlasec2.F
  dllsec2.F
  dmesec2.F
  docsec2.F
  dpssec2.F
  dsect4a.F
  dsgnbt.c
  dshsec2.F
  dsvsec2.F
  ecdef1.F
  ecdef1.h
  ecdef10.F
  ecdef10.h
  ecdef11.F
  ecdef11.h
  ecdef12.F
  ecdef12.h
  ecdef13.F
  ecdef13.h
  ecdef14.F
  ecdef14.h
  ecdef15.F
  ecdef15.h
  ecdef16.F
  ecdef16.h
  ecdef17.F
  ecdef17.h
  ecdef18.F
  ecdef18.h
  ecdef19.F
  ecdef19.h
  ecdef2.F
  ecdef2.h
  ecdef3.F
  ecdef3.h
  ecdef4.F
  ecdef4.h
  ecdef5.F
  ecdef5.h
  ecdef50.F
  ecdef6.F
  ecdef6.h
  ecdef7.F
  ecdef7.h
  ecdef8.F
  ecdef8.h
  ecdef9.F
  ecdef9.h
  ecdf190.h
  ecdf191.F
  ecdf191.h
  ecloc1.F
  eggsec2.F
  elasec2.F
  ellsec2.F
  emesec2.F
  eocsec2.F
  epssec2.F
  eshsec2.F
  esvsec2.F
  exscal.F
  extmap.F
  findLocalDefinitionFile.c
  fortranInterface.c
  ftn1cr.F
  gbitmap.F
  gdecode.c
  gdecode1.c
  gdecode2.c
  gdecodeStruct.h
  genbin.F
  gendir.F
  getchd.F
  getfb2.F
  getfpd.F
  getib1.F
  getib2.F
  getib3.F
  getind.F
  getlgd.F
  getsetValues.c
  getsetValues.h
  getsys.F
  getusr.F
  grbcom.h
  grchk1.F
  grchk2.F
  grchk3.F
  grchk4.F
  gribex.F
  gribex.h
  gribin.F
  gribnum.F
  grpr190.c
  grprs0.F
  grprs1.F
  grprs1b.F
  grprs2.F
  grprs3.F
  grprs4.F
  grprs4w.F
  grsdbg.F
  grsdef.F
  grsmax.F
  grsmkp.F
  grsmok.F
  grsn2o.F
  grsref.F
  grsrnd.F
  grsubc.F
  grsvck.F
  grsx2o.F
  gscale.F
  handleLocalDefinitions.c
  handleLocalDefinitions.h
  inscal.F
  insmp1.F
  insmp2.F
  inxbit.F
  inxmap.F
  jfree.c
  jmalloc.c
  kwchk1.F
  kwloc1.F
  kwprs1.F
  maxmin.F
  maxmn2.F
  maxmni.F
  modval.F
  offset.F
  offset2.F
  orefdat.c
  packcf.F
  prtbin.F
  prtbk1.F
  prtbk2.F
  prtbl1.F
  prtbl2.F
  ptquasi.F
  qu2reg.F
  qu2reg3.F
  reclen.F
  ref2grb.F
  remsp.F
  repchr.F
  revero.F
  rorint.F
  rowina.F
  rowina2.F
  rowina3.F
  rtb.F
  scm0.F
  sencode.c
  sencode1.c
  sencode2.c
  setpar.F
  sfbits.h
  swap4.c
  tab2fil.F
  u2l1cr.F
  uncmpck.F
  unpkcf.F
  valpina.c
  vod2uv.F
  yyyy2cy.F

  # this is not a complete list of headers, but they seem to be sufficient
  ecdef10.h
  ecdef11.h
  ecdef12.h
  ecdef13.h
  ecdef14.h
  ecdef15.h
  ecdef16.h
  ecdef17.h
  ecdef18.h
  ecdef19.h
  ecdef50.h
  eocsec2.h
  gdecode.h
  gdecode1.h
  gdecode2.h
  grib_int_t.h
  sencode.h
  sencode1.h
  sencode2.h
)

# emoscyc.F is not used anywhere and creates unref symbol when used in shared library
# however, it has been part of the static library and so it seems safer to keep it there
if(LIB_TYPE STREQUAL "STATIC")
  list(APPEND gribex_src_files emoscyc.F)
endif()


foreach( src ${gribex_src_files} )
  list( APPEND gribex_srcs gribex/${src} )
endforeach()

set( gribex_srcs ${gribex_srcs} PARENT_SCOPE )

=== interpolation/CMakeLists.txt ===
list( APPEND interpolation_src_files

  current.h
  grdynam.h
  grfixed.h
  grspace.h
  intf.h
  intlog.h
  jparams.h
  memreq.h
  parim.h

  areachk.F
  auresol.F
  chequal.F
  chkout.F
  chkprec.F
  clear_c.F
  ddstyle.F
  dpath_tables_interpol.F90
  dssarea.F
  estima.F
  fft99.F
  fixarea.F
  forced_fftw.F
  forced_nearest_neighbour.F
  freecf.F
  funcs.F
  gasetup.F
  getconf.F
  gettru.F
  gghtype.F
  ggintrp.F
  gglonlat.F
  ggrotat.F
  ggvalue.F
  global.F
  hgengg.F
  hgengrd.F
  hgengrw.F
  hgenll.F
  hgetlsm.F
  hirlam.F
  hirlamw.F
  hirlsm.F
  hll2ll.F
  hll2llw.F
  hll2xyz.F
  hnei12.F
  hneill.F
  hntfap.F
  hntfaph.F
  hntfaps.F
  hntfau.F
  hntfauh.F
  hntfaus.F
  hpshgpw.F
  hrg2gg.F
  hrg2ggw.F
  hsh2gg.F
  hsp2gg.F
  hsp2gg2.F
  hsp2gg3.F
  hwts12.F
  hwtsll.F
  hwtslsm.F
  iafree.F
  iagcntl.F
  iainit.F
  iarcntl.F
  ibasini.F
  igalloc.F
  igbess.F
  igdins.F
  igdiwe.F
  igglat.F
  iggmem.F
  iggrid.F
  igint.F
  igintr.F
  iglgrid.F
  iglsize.F
  iglsm01.F
  iglsmb.F
  iglsmd.F
  iglsmr.F
  iglsmst.F
  ignorm.F
  igplsm.F
  igpoleg.F
  igpolew.F
  igprec.F
  igsetup.F
  igsize.F
  igtog.F
  insane.F
  intf.F
  intfap.F
  intfau.F
  intfb.F
  intfbu.F
  intin.F
  intisl.F
  intlog.F
  intlogd.F
  intlogr.F
  intocn.F
  intocnu.F
  intout.F
  intpnum.F
  intuvdh.F
  intuvgh.F
  intuvp.F
  intuvs.F
  intuvu.F
  intuvxh.F
  intuvy.F
  intvecy.F
  intwave2.F
  intwavu.F
  irdiwe.F
  irgmem.F
  irgrid.F
  irgtog.F
  irint.F
  irintr.F
  irlsmb.F
  irprec.F
  irsize.F
  is_wave_direction.F
  iscrsz.F
  isggvalid.F
  islproc.F
  isoctahedral.F
  issame.F
  issameiarray.F
  issamerarray.F
  jacobi.F
  jagggp.F
  jallgp.F
  jallwn.F
  jbess.F
  jdebug.F
  jfindfn.F
  jfindfn3.F
  jfindir.F
  jgetgg.F
  jgglat.F
  jjset99.F
  jmakgg.F
  jmakgg3.F
  jmakll.F
  jmakll3.F
  jmemhan.F
  jmemhan2.F
  jmkofgg.F
  jmovgg.F
  jmovll.F
  jmvugg.F
  jmvull.F
  jnorsgg.F
  jnumgg.F
  jopngg.F
  jopnggf.F
  jopnll.F
  jopnllf.F
  jreadgg.F
  jreadll.F
  jsgggp.F
  jsh2sh.F
  jsllgp.F
  jspleg1.F
  jsppole.F
  jstrll.F
  jstrwll.F
  jsymgg.F
  jsymll.F
  juvpole.F
  jvod2uv.F
  jwindll.F
  jwscal.F
  kintrg.F
  knfrom4.F
  krg2rg.F
  krg2rgd.F
  krg2rgu.F
  krg2rgy.F
  krg2rgz.F
  ll2xyz.F
  lsm_red.F
  lsmfld.F
  mkbitmp.F
  mkframe.F
  newisl.F
  ngintrp.F
  ngrotat.F
  ngvalue.F
  nmakgg.F
  nmakll.F
  numptns.F
  numptwe.F
  oceanp.F
  oceanu.F
  outrep.F
  pddefs.F
  precip.F
  qgoct.F
  qpassm.F
  reset_c.F
  rpassm.F
  rphi.F
  set99.F
  setrep.F
  sscal.F
  strlat.F
  w251idx.F
  waveidx.F
  wavexx2.F
  wv2didx.F
  wv2dint.F
  wv2dxx2.F
  wvqlidx.F
  wvqlint.F
  xyz2ll.F
  yrotate.F
  zprec.F

  emosPrecision.c
  fftchk.c
  gmapbit.c
  hirlam_userspace.c
  intlogs.c
  jchmod.c
  jindex.c
  jopnggsm.c
  jopnllsm.c
  makemap.c
  rename_unlink.c
  shareddt.c
  sharedgg.c
  sharedlib.c
  sharedll.c

  # (former grib_api_merging/)
  copy_spec_from_ksec.c
  describe_input_field.c
  emos.c
  emos.h
  intf2.c
  intuvp2.c
  intuvs2.c
  intvect2.c
)


foreach( src ${interpolation_src_files} )
  list( APPEND interpolation_srcs interpolation/${src} )
endforeach()

set( interpolation_srcs ${interpolation_srcs} PARENT_SCOPE )

=== libemos-dp/CMakeLists.txt ===
# library sources
foreach( _src ${libemos_srcs} )
  list( APPEND emos_dp_srcs ../${_src} )
endforeach()


# compiler definitions:
# - configure Fortran-based targets for double precision (compilation & linking)
# - allow/disallow GRIBEX with configuration
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()
if( HAVE_GRIBEX_ABORT )
  set_source_files_properties(
    "../gribex/gribex.F"
    PROPERTIES COMPILE_DEFINITIONS "GRIBEX_ABORT" )
endif()
if( HAVE_LIBEMOS_INTERPOLATION AND HAVE_FFTW )
  set_source_files_properties(
    "../interpolation/jagggp.F"
    "../interpolation/jsymgg.F"
    PROPERTIES COMPILE_DEFINITIONS "HAVE_FFTW" )
endif()


# library target
set( CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( ${LIBEMOS_BASE_DIR}/interpolation ${LIBEMOS_BASE_DIR}/bufrdc_wmo )

ecbuild_add_library(
  TYPE        ${LIB_TYPE}
  TARGET      emos
  OUTPUT_NAME "emosR64"
  DEFINITIONS ${LIBEMOS_DEFINITIONS} ${emos_interpol_tables_def}
  LIBS        "${GRIB_API_LIBRARIES}" "${FFTW_LIB}" ${FORTRAN_LIBRARIES}
  SOURCES     ../libemos_version.c ${emos_dp_srcs}
  GENERATED   ../libemos_version.c )


#if( BUILD_SHARED_LIBS )
#  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
#               libemosR64.so ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R64.D64.I32.so)" )
#else()
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
               libemosR64.a ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R64.D64.I32.a)" )
#endif()

=== libemos-sp/CMakeLists.txt ===
# library sources (copy)
foreach( _src ${libemos_srcs} )
  add_custom_command(
    OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${_src}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${LIBEMOS_BASE_DIR}/${_src} ${CMAKE_CURRENT_BINARY_DIR}/${_src}
    COMMENT "copying ${_src} from emos (sp)"
    DEPENDS ${LIBEMOS_BASE_DIR}/${_src} )
  list( APPEND emos_sp_srcs ${CMAKE_CURRENT_BINARY_DIR}/${_src} )
endforeach()


# compiler definitions:
# - exclude double-precision specific definitions
# - allow/disallow GRIBEX with configuration
list( REMOVE_ITEM LIBEMOS_DEFINITIONS REAL_8 REAL_BIGGER_THAN_INTEGER )
if( HAVE_GRIBEX_ABORT )
  set_source_files_properties(
    "${CMAKE_CURRENT_BINARY_DIR}/gribex/gribex.F"
    PROPERTIES COMPILE_DEFINITIONS "GRIBEX_ABORT" )
endif()
if( HAVE_LIBEMOS_INTERPOLATION AND HAVE_FFTW )
  set_source_files_properties(
    "${CMAKE_CURRENT_BINARY_DIR}/interpolation/jagggp.F"
    "${CMAKE_CURRENT_BINARY_DIR}/interpolation/jsymgg.F"
    PROPERTIES COMPILE_DEFINITIONS "HAVE_FFTW" )
endif()


# library target
set( CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( ${LIBEMOS_BASE_DIR}/interpolation ${LIBEMOS_BASE_DIR}/bufrdc_wmo )

ecbuild_add_library(
  TYPE        ${LIB_TYPE}
  TARGET      emos_sp
  OUTPUT_NAME "emos"
  DEFINITIONS ${LIBEMOS_DEFINITIONS} ${emos_interpol_tables_def}
  LIBS        "${GRIB_API_LIBRARIES}" "${FFTW_LIB}" "${FORTRAN_LIBRARIES}"
  SOURCES     ../libemos_version.c ${emos_sp_srcs}
  GENERATED   ../libemos_version.c )


#if( BUILD_SHARED_LIBS )
#  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
#               libemos.so ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R32.D64.I32.so)" )
#else()
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
               libemos.a ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R32.D64.I32.a)" )
#endif()

=== pbio/CMakeLists.txt ===
list( APPEND pbio_src_files
  bufrgrib.h
  fort2c.h
  blokex.F
  pbbufr.F
  pbcrex.F
  pbgrib.F
  pbionum.F
  emosnum.F
  pbpseu.F
  PBGroutines.c
  extras.c
  fort2c.c
  lwsize.c
  mvchars.c
  pbio.c
  readany.c
  readbufr.c
  readcrex.c
  readgrib.c
  readnext.c
  readprod.c
  recheckLength.c
  gbyte_le.c

  # this is not a complete list of headers, but they seem to be sufficient
  PBGroutines.h
  fileRead.h
  sizeRoutines.h
)

foreach( src ${pbio_src_files} )
  list( APPEND pbio_srcs pbio/${src} )
endforeach()

set( pbio_srcs ${pbio_srcs} PARENT_SCOPE )

=== tests/CMakeLists.txt ===

# test settings and helper functions
include("${PROJECT_SOURCE_DIR}/tests/settings.cmake")

# configure Fortran-based targets for double precision (compilation & linking)
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()


################ I N T E R P O L A T I O N ################

if( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )

  # intuvp2: interpolation to different formats
  foreach( rotated "" "rotated_" )
    foreach( out "regular_ll" "F80" "N80" "O80" )
      set( in "vo-d_sh" )
      set( label "intuvp2_${in}_to_${rotated}${out}" )
      if(     NOT (label MATCHES "sh_to_O" AND NOT HAVE_FFTW)
          AND NOT (label MATCHES "_to_rotated_[NOF]") )
        set( input "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib" )
        set( refer "${PROJECT_SOURCE_DIR}/tests/data/${label}.grib.ref" )
        set( output "${label}.grib" )
        unset( opt )
        if( out MATCHES "^regular_ll" )
          list( APPEND opt "--INTOUT:grid=3.0/3.0" )
        else()
          list( APPEND opt "--INTOUT:gridname=${out}" )
        endif()
        if( "${rotated}" STREQUAL "rotated_" )
          list( APPEND opt "--INTOUT:rotation=30/30" )
        endif()
        list( APPEND opt "--intuvp2" )

        interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" )
        interpolation_add_test_compare(  ${label} "${refer}" "${output}" )

        unset( opt )
        unset( output )
        unset( refer )
        unset( input )
      endif()
      unset( label )
      unset( in )
    endforeach()
  endforeach()

  # intf2: interpolation to different formats
  # not possible:
  # - regular_ll to reduced Gaussian (G) (but regular_ll to regular G is possible)
  # - regular G to reduced G
  # - any to rotated reduced/regular G
  # - regular_ll to rotated regular_ll
  foreach( rotated "" "rotated_" )
    foreach( in "vo-d_sh" "z_sh" "msl_regular_ll" "msl_N640" "2t_O640" "q_F640" )
      foreach( out "regular_ll" "F80" "N80" "O80" "F48" )
        set( label "intf2_${in}_to_${rotated}${out}" )
        if(     NOT (label MATCHES "regular_ll_to_[NO]")
            AND NOT (label MATCHES "F.*_to_[NO]")
            AND NOT (label MATCHES "_to_rotated_[NOF]")
            AND NOT (label MATCHES "regular_ll_to_rotated_regular_ll$")
            AND NOT (label MATCHES "sh_to_O" AND NOT HAVE_FFTW) )
          set( input "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib" )
          set( refer "${PROJECT_SOURCE_DIR}/tests/data/${label}.grib.ref" )
          set( output "${label}.grib" )
          unset( opt )
          if( out MATCHES "^regular_ll" )
            list( APPEND opt "--INTOUT:grid=0.5/0.5" )
          else()
            list( APPEND opt "--INTOUT:gridname=${out}" )
          endif()
          if( "${rotated}" STREQUAL "rotated_" )
            list( APPEND opt "--INTOUT:rotation=30/30" )
          endif()
          list( APPEND opt "--INTOUT:autoresol=1" "--INTOUT:area=0/0/0/0" "--intf2" )

          interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" )
          interpolation_add_test_compare( ${label} "${output}" "${refer}" )

          unset( opt )
          unset( output )
          unset( refer )
          unset( input )
        endif()
        unset( label )
      endforeach()
    endforeach()
  endforeach()


  # intf2: interpolate to N/O grids with the same N
  # (distinguish between N640 <> O640)
  foreach( in "N640" "O640" )
    foreach( out "N640" "O640" )
      set( label "intf2_${in}_to_${out}" )
      set( output "${label}.grib" )
      unset( opt )
      list( APPEND opt "--INTOUT:gridname=${out}" "--INTOUT:autoresol=1" "--INTOUT:area=0/0/0/0" "--intf2" )

      if( in MATCHES "N640" )
        set( input "${PROJECT_SOURCE_DIR}/tests/data/msl_${in}.grib" )
      else()
        set( input "${PROJECT_SOURCE_DIR}/tests/data/2t_${in}.grib" )
      endif()
      interpolation_add_test_interpol( ${label} "${input}" "${output}" "${opt}" )
      interpolation_add_test_compare(  ${label} "${input}" "${output}" )
      interpolation_add_test_gridname( ${label} ${output} ${out} )
      if( NOT in STREQUAL out )
        set_tests_properties( ${label}_compare PROPERTIES WILL_FAIL TRUE )
      endif()

      unset( opt )
      unset( input )
      unset( output )
      unset( label )
    endforeach()
  endforeach()


  # intf2: compare FFT99 vs FFTW exactly (no tolerance!)
  if( HAVE_FFTW )
    foreach( in "vo-d_sh" "z_sh" )
      set( input "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib" )
      set( output_fftw  "intf2_${in}_to_N80-fftw.grib" )
      set( output_fft99 "intf2_${in}_to_N80.grib" )
      unset( opt )
      list( APPEND opt "--INTOUT:gridname=N80" "--INTOUT:autoresol=1" "--intf2" )

      interpolation_add_test_interpol( "intf2_${in}_to_N80_fft99_vs_fftw" "${input}" "${output_fftw}" "${opt}" "" "EMOSLIB_FORCED_FFTW=1" )
      interpolation_add_test_compare( "intf2_${in}_to_N80_fft99_vs_fftw" "${output_fftw}" "${output_fft99}" )

      unset( opt )
      unset( output_fft99 )
      unset( output_fftw )
      unset( input )
    endforeach()
  endif( HAVE_FFTW )


  # intf2: test SH truncation
  set( in "vo-d_sh" )
  set( opt "--INTOUT:truncation=63" "--intf2" )
  interpolation_add_test_interpol(
      "intf2_${in}_to_${in}_trunc"
      "${PROJECT_SOURCE_DIR}/tests/data/${in}.grib"
      "intf2_${in}_to_${in}_trunc.grib"
      "${opt}" )
  unset( opt )
  unset( in )


endif( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )


####################### G R I B E X #######################

if( HAVE_LIBEMOS_GRIBEX )

    ecbuild_add_test( TARGET gribex_abort SOURCES gribex_abort.F LIBS emos ENVIRONMENT ${_emos_environment} )
    ecbuild_add_test( TARGET gribex_demo  SOURCES gribex_demo.F  LIBS emos ENVIRONMENT ${_emos_environment}
      ARGS -i "${PROJECT_SOURCE_DIR}/tests/data/msl_regular_ll.grib" )

    set_tests_properties( gribex_abort PROPERTIES WILL_FAIL ${HAVE_GRIBEX_ABORT} )
    set_tests_properties( gribex_demo  PROPERTIES WILL_FAIL ${HAVE_GRIBEX_ABORT} )

endif( HAVE_LIBEMOS_GRIBEX )


######################### B U F R #########################

if( HAVE_LIBEMOS_BUFRDC AND ENABLE_INSTALL_TOOLS )
  add_subdirectory( bufr )
endif( HAVE_LIBEMOS_BUFRDC AND ENABLE_INSTALL_TOOLS )


############ T E S T S :   R E G R E S S I O N ############

if( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )
  if( HAVE_LIBEMOS_TESTS_REGRESS )
    add_subdirectory( regress )
  endif()
endif( HAVE_LIBEMOS_INTERPOLATION AND ENABLE_INSTALL_TOOLS )


###################### M S   A P P S ######################

add_subdirectory( ms_apps )


################ S P E C I A L   T E S T S ################

if( HAVE_LIBEMOS_INTERPOLATION )

    # linking (build-time) test(s)
    foreach( src "example_intf2.F" "example_intuvp2.F" "link_mars.F" "link_prodgen.F" )
        get_filename_component( test ${src} NAME_WE )
        ecbuild_add_executable( TARGET ${test} NOINSTALL SOURCES ${src} LIBS emos )
        unset( test )
    endforeach()
    ecbuild_add_executable( TARGET "example_intf" NOINSTALL SOURCES "example_intf.F90" LIBS emos CONDITION (HAVE_FORTRAN AND NOT CMAKE_Fortran_COMPILER_ID MATCHES "PGI") )

    # run-time test(s)
    foreach( test "test_fft99" "test_hsp2gg" )
        ecbuild_add_test( TARGET ${test} SOURCES ${test}.F LIBS emos )
    endforeach()
    ecbuild_add_test( TARGET "test_fftw" SOURCES "test_fftw.F" LIBS emos CONDITION HAVE_FFTW )

endif( HAVE_LIBEMOS_INTERPOLATION )

=== tools/CMakeLists.txt ===
# configure Fortran-based targets for double precision (compilation & linking)
if (NOT emos_double_precision_flags STREQUAL "")
  ecbuild_add_fortran_flags(${emos_double_precision_flags})
endif()

if( HAVE_LIBEMOS_BUFRDC )
  add_subdirectory( bufrtools_wmo )
endif()

if( HAVE_LIBEMOS_INTERPOLATION )

  add_subdirectory( lsmReducedGaussian )

  if( NOT HAVE_GRIBEX_ABORT )
    add_subdirectory( singlePointInterpolation )
  endif()

  ecbuild_add_executable(
    TARGET      gg_latitudes NOINSTALL
    SOURCES     gg_latitudes.F
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    LIBS        emos )

  if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )

    set_source_files_properties( gg_gridname.c PROPERTIES COMPILE_DEFINITIONS "FORTRAN_LINKER_PGI" )
    ecbuild_add_executable(
      TARGET      gg_gridname NOINSTALL
      SOURCES     gg_gridname.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos
      LINKER_LANGUAGE Fortran )

    set_source_files_properties( gg_single.c PROPERTIES COMPILE_DEFINITIONS "FORTRAN_LINKER_PGI" )
    ecbuild_add_executable(
      TARGET      gg_single NOINSTALL
      SOURCES     gg_single.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos
      LINKER_LANGUAGE Fortran )

  else()
    ecbuild_add_executable(
      TARGET      gg_gridname NOINSTALL
      SOURCES     gg_gridname.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos )
    ecbuild_add_executable(
      TARGET      gg_single NOINSTALL
      SOURCES     gg_single.c
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      INCLUDES    ${GRIB_API_INCLUDE_DIRS}
      LIBS        emos )
  endif()

  ecbuild_add_executable(
    TARGET      int NOINSTALL
    SOURCES     int.F except.c
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    INCLUDES    ${GRIB_API_INCLUDE_DIRS}
    LIBS        emos )

endif()

=== debian/changelog ===
emoslib (2:4.5.9-8) unstable; urgency=medium

  * Fix for FTBFS because of deprecated code in eccodes.
    Closes: #1033427

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Mar 2023 09:55:22 +0100

emoslib (2:4.5.9-7) unstable; urgency=medium

  * Change gfortran conditional flags to work with gfortran 11.
    Closes: #984046
  * Standards-Version:4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 06 Sep 2021 20:11:18 +0100

emoslib (2:4.5.9-6) unstable; urgency=medium

  * Fix needed for gfortran-10 changes. Closes: #966956
  * Move to debhelper level 13.
  * Use subst vars rather than autogenerated dh files.
  * List all non-installed files in d/not-installed.
    Ship libemos*. headers, links.sh script

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Aug 2020 20:47:15 +0100

emoslib (2:4.5.9-5) unstable; urgency=medium

  * Set ECBUILD_MACROS_DIR to fix FTBFS. Closes: #963404

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 22 Jun 2020 16:38:30 +0100

emoslib (2:4.5.9-4) unstable; urgency=medium

  * Use ecbuild buildsystem rather than cmake
  * Standards-Version: 4.5.0
  * Fix FTBFS on gfortran10.  Closes: #957171

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 22 Apr 2020 14:47:35 +0100

emoslib (2:4.5.9-3) unstable; urgency=medium

  * Drop B-D on libpython2.7-dev. Closes: #936479

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Sep 2019 16:45:43 +0100

emoslib (2:4.5.9-2) unstable; urgency=medium

  * Standard-Version: 4.4.0
  * Build-Depend on gfortran | fortran-compiler
  * Use debhelper-compat (= 12)
  * Drop obsolete Pre-Depends in d/control (needed for multiarch)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Aug 2019 08:59:44 +0100

emoslib (2:4.5.9-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 05 Dec 2018 05:06:10 +0000

emoslib (2:4.5.7-2) unstable; urgency=medium

  * Fix from John David Anglin for hppa FTBFS of metview. Closes: #905534

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Oct 2018 10:19:16 +0000

emoslib (2:4.5.7-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.2.1
  * Drop hard-coded xz compression in source/options
  * Drop B-D on grib-api-tools; obsolete

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Oct 2018 05:36:57 +0100

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,19 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>=10), 
- gfortran, 
- cmake (>= 2.8.11), 
+Build-Depends: debhelper-compat (=13), 
+ gfortran | fortran-compiler, 
+ ecbuild (>= 3.3.0-2),
  libboost-dev (>= 1.47.0), 
  libboost-test-dev, 
  chrpath,
  libeccodes-dev (>= 2.4.1),
- libeccodes-tools | libgrib-api-tools,
+ libeccodes-tools,
  libopenjp2-7-dev,
  zlib1g-dev,
  libfftw3-dev,
- libpython2.7-dev, 
  libnetcdf-dev
-Standards-Version: 4.1.5
+Standards-Version: 4.6.0
 Homepage: https://software.ecmwf.int/wiki/display/EMOS/Emoslib
 Vcs-Browser: https://salsa.debian.org:/science-team/emos
 Vcs-Git: https://salsa.debian.org:/science-team/emos.git
@@ -25,7 +24,6 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data
-Pre-Depends: ${misc:Pre-Depends}
 Description: ECMWF Interpolation Library
  The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
  BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological

=== debian/watch ===
version=3
https://confluence.ecmwf.int/display/EMOS/Releases /download/attachments/3473472/libemos\-(.+)\-Source\.tar\.gz\?api=v2
